import "reflect-metadata";
import {validate as $QdH60$validate} from "class-validator";
import {initializerDefineProperty as $QdH60$initializerDefineProperty, applyDecoratedDescriptor as $QdH60$applyDecoratedDescriptor} from "@swc/helpers";
import {observable as $QdH60$observable, computed as $QdH60$computed} from "mobx";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $571b30dc9677e402$exports = {};

$parcel$export($571b30dc9677e402$exports, "Body", function () { return $571b30dc9677e402$export$4b2c32e08f77ff18; });
$parcel$export($571b30dc9677e402$exports, "checkInput", function () { return $571b30dc9677e402$export$87fe1a1c81bdcb6f; });


function $571b30dc9677e402$export$4b2c32e08f77ff18() {
    return (target, key, index)=>Reflect.defineMetadata(`mobx-restful-body-${key}`, index, target)
    ;
}
function $571b30dc9677e402$export$87fe1a1c81bdcb6f() {
    return (target, key, meta)=>{
        const index = Reflect.getMetadata(`mobx-restful-body-${key}`, target);
        const { [index]: Model  } = Reflect.getMetadata('design:paramtypes', target, key), method = meta.value;
        meta.value = async function(...data) {
            if (Model) {
                const validator = data[index] = Object.assign(new Model(), data[index]);
                const [error] = await $QdH60$validate(validator);
                if (error) throw new Error(error.constraints && Object.values(error.constraints)[0]);
            }
            return method.apply(this, data);
        };
    };
}


var $ffade165a83d927a$exports = {};

$parcel$export($ffade165a83d927a$exports, "BaseStore", function () { return $ffade165a83d927a$export$f6772e87ca157ef; });
$parcel$export($ffade165a83d927a$exports, "toggle", function () { return $ffade165a83d927a$export$e03c1c3201ee8bb7; });


var _class, _descriptor, _descriptor1, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _dec, _dec1, _dec2, _dec3;
let $ffade165a83d927a$export$f6772e87ca157ef = (_class = class BaseStore {
    get totalPage() {
        return Math.ceil(this.totalCount / this.pageSize);
    }
    get noMore() {
        return this.pageIndex >= this.totalPage;
    }
    clearCurrent() {
        this.current = {
        };
    }
    clearList() {
        this.list = [];
    }
    async updateOne(data, id) {
        const full = await (id ? this.request('PUT', `${this.path}/${id}`, data) : this.request('POST', this.path, data));
        return this.current = full;
    }
    async getOne(id1) {
        const full = await this.request('GET', `${this.path}/${id1}`);
        return this.current = full;
    }
    deleteOne(id2) {
        return this.request('DELETE', `${this.path}/${id2}`);
    }
    async getList(filter) {
        const data = await this.requestPage(this.path, filter);
        Object.assign(this, data);
        return this.list;
    }
    constructor(){
        $QdH60$initializerDefineProperty(this, "loading", _descriptor, this);
        $QdH60$initializerDefineProperty(this, "updating", _descriptor1, this);
        $QdH60$initializerDefineProperty(this, "current", _descriptor2, this);
        $QdH60$initializerDefineProperty(this, "keyword", _descriptor3, this);
        $QdH60$initializerDefineProperty(this, "pageIndex", _descriptor4, this);
        $QdH60$initializerDefineProperty(this, "pageSize", _descriptor5, this);
        $QdH60$initializerDefineProperty(this, "totalCount", _descriptor6, this);
        $QdH60$initializerDefineProperty(this, "list", _descriptor7, this);
    }
}, _descriptor = $QdH60$applyDecoratedDescriptor(_class.prototype, "loading", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return false;
    }
}), _descriptor1 = $QdH60$applyDecoratedDescriptor(_class.prototype, "updating", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return false;
    }
}), _descriptor2 = $QdH60$applyDecoratedDescriptor(_class.prototype, "current", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return {
        };
    }
}), _descriptor3 = $QdH60$applyDecoratedDescriptor(_class.prototype, "keyword", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: void 0
}), _descriptor4 = $QdH60$applyDecoratedDescriptor(_class.prototype, "pageIndex", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return 1;
    }
}), _descriptor5 = $QdH60$applyDecoratedDescriptor(_class.prototype, "pageSize", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return 10;
    }
}), _descriptor6 = $QdH60$applyDecoratedDescriptor(_class.prototype, "totalCount", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return 0;
    }
}), _descriptor7 = $QdH60$applyDecoratedDescriptor(_class.prototype, "list", [
    $QdH60$observable
], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function() {
        return [];
    }
}), $QdH60$applyDecoratedDescriptor(_class.prototype, "totalPage", [
    $QdH60$computed
], Object.getOwnPropertyDescriptor(_class.prototype, "totalPage"), _class.prototype), $QdH60$applyDecoratedDescriptor(_class.prototype, "noMore", [
    $QdH60$computed
], Object.getOwnPropertyDescriptor(_class.prototype, "noMore"), _class.prototype), _dec = $ffade165a83d927a$export$e03c1c3201ee8bb7('updating'), $QdH60$applyDecoratedDescriptor(_class.prototype, "updateOne", [
    _dec
], Object.getOwnPropertyDescriptor(_class.prototype, "updateOne"), _class.prototype), _dec1 = $ffade165a83d927a$export$e03c1c3201ee8bb7('loading'), $QdH60$applyDecoratedDescriptor(_class.prototype, "getOne", [
    _dec1
], Object.getOwnPropertyDescriptor(_class.prototype, "getOne"), _class.prototype), _dec2 = $ffade165a83d927a$export$e03c1c3201ee8bb7('updating'), $QdH60$applyDecoratedDescriptor(_class.prototype, "deleteOne", [
    _dec2
], Object.getOwnPropertyDescriptor(_class.prototype, "deleteOne"), _class.prototype), _dec3 = $ffade165a83d927a$export$e03c1c3201ee8bb7('loading'), $QdH60$applyDecoratedDescriptor(_class.prototype, "getList", [
    _dec3
], Object.getOwnPropertyDescriptor(_class.prototype, "getList"), _class.prototype), _class);
function $ffade165a83d927a$export$e03c1c3201ee8bb7(statusKey) {
    return (target, key, meta)=>{
        const origin = meta.value;
        meta.value = async function(...data) {
            Reflect.set(this, statusKey, true);
            try {
                return await origin.apply(this, data);
            } finally{
                Reflect.set(this, statusKey, false);
            }
        };
    };
}




export {$571b30dc9677e402$export$4b2c32e08f77ff18 as Body, $571b30dc9677e402$export$87fe1a1c81bdcb6f as checkInput, $ffade165a83d927a$export$f6772e87ca157ef as BaseStore, $ffade165a83d927a$export$e03c1c3201ee8bb7 as toggle};
//# sourceMappingURL=index.esm.js.map
